Name:			perl-Data-HashArray
Version:		1.0
Release:		1%{?dist}
Summary:		Array class of hashes that has magical properties via overloading and AUTOLOAD
License:		GPL+ or Artistic
Group:			Development/Libraries
URL:			http://search.cpan.org/dist/Data-HashArray/
Source0:		http://www.cpan.org/modules/by-module/Data/Data-HashArray-%{version}.tar.gz
BuildRoot:		%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:		noarch
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(Test::Simple)
Requires:		perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

%description
Normally, Data::HashArray is an array of hashes or hash-based objects. This
class has some magical properties that make it easier to deal with
multiplicity.

First, there exist two overloads. One for hash access and the other for
stringification. Both will act on the first element of the array. In other
words, performing a hash access on an object of this class will be equivalent
to performing a hash access on the first element of the array.

Second, the AUTOLOAD method will delegate any method unknown to this class to
the first item in the array as well. For this to work, at least the first item
of the array better be an object on which one could call such a method.

Both of these magical properties make it easier to deal with unpredictable
multiplicity. You can both treat the object as an array or as hash (the first
one in the array). This way, if your code doesn't know that an element can
occur multiple times (in other words, if the code treats the element as
singular), the same code should still largely work when the singular element
is replaced by a Data::HashArray object.

The other practical feature of this class is the capability to place the
objects (or hashes) in the array into a hash keyed on the value of a given
field or fields (see the "hash()" method for further details).

%prep
%setup -q -n Data-HashArray-%{version}

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}

make pure_install PERL_INSTALL_ROOT=%{buildroot}

find %{buildroot} -type f -name .packlist -exec rm -f {} \;
find %{buildroot} -depth -type d -exec rmdir {} 2>/dev/null \;

%{_fixperms} %{buildroot}/*

%check
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README
%{perl_vendorlib}/*
%{_mandir}/man3/*

%changelog
* Sun Jun 17 2012 asides@lbl.gov 1.0-1
- Specfile autogenerated by cpanspec 1.77.
